//Fluchtdiagramm für die Standardmap
//Es kommt wegen der multithreaded Graphic zu einigen wenigen Pixelfehlern
//////////////////////////////////////////////////////////////////////////////////
public class MyThread extends Thread {  
  double xmin,ymin;
  color farbe;
  PGraphics pg;
  int maxiterations;
  double massFuerUnendlich;
  double x0,y0,xAlt,yAlt,xNeu,xNeuA,yNeu;
  double yMin, yMax;
  double wh;
  double K;
  //boolean imChaosBand;
  protected boolean running = false;
  

  //-----------------------------------------
  // Thread anlegen und Parameter übergeben
  //-----------------------------------------
  
  public MyThread(double px0, double py0, int pmaxiterations, double pmUnendlich, double pwh, double KFaktor) {
    // benötigte Parameter
    K = KFaktor;
    wh = pwh;
    xmin=px0; ymin=py0; 
    maxiterations = pmaxiterations;
    massFuerUnendlich = pmUnendlich; 
    //imChaosBand = false;
    pg = createGraphics(width,height/anzahlThreads);
    
  }

 //////////////////////////////////////////////////////////////  
  public void run() {
    
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
       // println("x: "+xmin,xmax);//Information
        double ymax = ymin + wh;
        //println("y: "+ymin,ymax);//Information
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j = 0; j < pg.height; j++) {
          double x = xmin;
          for (int i = 0; i < pg.width; i++) {
            double D = standardMapIteration(x, y, maxiterations);
            pg.pixels[i+j*pg.width] = colorize(D);  
            x += dx;
          }   
          y += dy;
        }
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
   
  }
  
/////////////////////////////////////////////////////////////////////
 double standardMapIteration(double xH, double yH, int maxN) {
  //Standardmap Algorithmus zur Berechung des Durchschnitt des Abstand des Originalpunktes zu den Punkten nach maxN Iterationen
    int  maxit = maxN;
    double d = 0;
    x0 = xH; y0=yH; 
    xAlt = xH; yAlt = yH;
    yMin = 0; yMax = 0;
    int i = 0;
    while (i < maxit) {
      yNeu = (yAlt + K*Math.sin(xAlt)) ;
      xNeu = (xAlt + yNeu) ;  
      //Der Wertebereich wird hier nicht auf den Definitionsbereich eingeschränkt (modulo)
      //weil sonst die Abstandswerte d sinnlos werden können.
      d = d +Math.sqrt((x0-xNeu)*(x0-xNeu)+(y0-yNeu)*(y0-yNeu)); 
      //Interessante Alternative: Durchschnitt der Abstände zwischen zwei 
      //aufeinanderfolgenden Punkten:
      //  d = d +Math.sqrt((xAlt-xNeu)*(xAlt-xNeu)+(yAlt-yNeu)*(yAlt-yNeu)); 
  
      xAlt = xNeu;yAlt = yNeu;      
      i++;
    }  
    d = 64*d/maxit;   
    return d;
 }

/////////////////////////////////////////////////////////////
color colorize(double dist) {
    // jedes Pixel wird entsprechend der Anzahl Iterationen eingefärbt
      color col; 
      col = color(8*(int)dist%256,255,2*(int)dist%255); 
      return col; 
    
  }

}
