//////////////////////////////////////////////////////////////////
//Fluchtdiagramm der Standardmap
//Methode: Es wird bei der durchschnittliche Abstand vom ersten Punkt berechnet
//Alternativ: Durchschnitt des Abstands zum nächsten Punkt 
//In beiden Fällen wird der Wert farblich codiert
//Bis zu 1 000 000 -fache Vergrößerungen sind möglich
/////////////////////////////////////////////////////////////////

ArrayList<MyThread> workers;
double xmin = 0; 
double ymin = -Math.PI; 
double wh = 2*Math.PI;
int maxiterations = 50; //10000;
double massFuerUnendlich = 1000;
int anzahlThreads = Runtime.getRuntime().availableProcessors();//Bild ohne Math.PIxelfehler wähle anzahlThreads =1
double K = 0.971635;
//double K = 0.5;
PImage bild, bildGedreht;
float vFaktor = 1  ;
double xSpecial , ySpecial;//Für Testzwecke
boolean achseZeichnen;

void setup() {
  background(255);
  colorMode(HSB);
  achseZeichnen = true;
  workers = new  ArrayList<MyThread>(); 
  size(800, 800);
  println("Anzahl Threads: "+anzahlThreads);
  starteThreads(xmin, ymin, maxiterations, massFuerUnendlich, wh);
 
  bild = createImage(width,height,HSB);
  bildGedreht = createImage(width,height,HSB);
}
////////////////////////////////////////////////////////////////////
void starteThreads(double px, double py, int pmaxiterations, double pUnendlich, double pwh){
  
  xmin = px; ymin = py;
  maxiterations = pmaxiterations;
  massFuerUnendlich = pUnendlich;
  wh = pwh;
  for (double y= ymin; y<(ymin+wh); y=y+wh/anzahlThreads) {
        MyThread t = new MyThread(xmin,y,maxiterations,massFuerUnendlich,wh/anzahlThreads,K);
        workers.add(t);
        t.start();  
        delay(50);//einzelne Math.PIxelfehler sind so sehr selten
   }  
}


//////////////////////////////////////////////////////////////

void draw() {
  
  // die Draw-Methode fügt die PGraphics-Zeichenflächen
  // der Threads zu einem Bild zusammen
  // Warten bis alle Threads fertig sind
 
  for(MyThread t: workers){
      while (t.running){       
            try{
            Thread.sleep(10);  
            }catch (Exception e) {  }  ;                
       }
  }
  
  for (int i =0; i< workers.size(); i++){
    image(workers.get(i).pg,0,i*height/anzahlThreads);
    
  }
  //Initialisierung der Math.PImages
   bild = get();
   bildGedreht = get();
   //weil negativer y-Bereich bisher oben ist SMath.PIegelung an x-Achse
 
   for (int i = 0; i < bildGedreht.width; i++){
      for (int j = 0; j < bildGedreht.height; j++) {
           bildGedreht.set(i,j,bild.get(i,bild.height-j-1));
      }
    }
    image(bildGedreht,0,0);
    if(achseZeichnen){
     stroke(255,100);
     line(400,0,400,800);  
     line(0,400,800,400);
     achseZeichnen = false;
    } 
   noLoop();  
}

/////////////////////////////////////////////////////////////////
void mousePressed() {
      
   workers = new  ArrayList<MyThread>(); 
  // berechne, wo der Mauszeiger im gezeigten Ausschnitt der 
  // Zahlenebene ist (Transformation Math.PIxelposition nach (x,y))
  double x = xmin + wh*mouseX/width;
  double y = ymin + wh*(height-mouseY)/height;//negativer y-Wert muss unten sein
  //println(x,y);
  // linke Maustaste: verkleinere den gezeigten Ausschnitt um 0.5
  // rechte Taste: vergrößere den gezeigten Ausschnitt entsprechend
  if (mouseButton == LEFT) {
    vFaktor = 2*vFaktor; 
   println("Zoomfaktor: "+vFaktor+"-fach"); 
  
   wh*=0.5;
  }
  if (mouseButton == RIGHT) {
    wh/=0.5;
    vFaktor = vFaktor/2;
    println("Zoomfaktor: "+vFaktor+"-fach"); 
  }
  // bestimme den neuen gezeigten Ausschnitt
  xmin = x-wh/2.0;
  ymin = y-wh/2.0;
  starteThreads(xmin, ymin, maxiterations, massFuerUnendlich, wh);

  redraw();
}  
/////////////////////////////////////////////////////////////////
void keyPressed() {
  if (key == '+'){
    maxiterations *= 1.2;
    workers = new  ArrayList<MyThread>(); 
    starteThreads(xmin, ymin, maxiterations, massFuerUnendlich, wh);
  }
  if (key == '-') {
    maxiterations /= 1.2;
    workers = new  ArrayList<MyThread>(); 
    starteThreads(xmin, ymin, maxiterations, massFuerUnendlich, wh);  
  }
  if (key == 'p') {
    xSpecial = 3.136356830596924;
    ySpecial = 0.0 ;
    double xS = xSpecial; 
    double yS = ySpecial;
    double xSNeu = xSpecial; 
    double ySNeu = ySpecial;
    double d =0;
     int i = 0;
      while (i < maxiterations) {
       
        ySNeu = (yS + K*Math.sin(xS)) ;//% (2*Math.PI); 
        xSNeu = (xS + ySNeu) % (2*Math.PI);  
        if(xSNeu <0) xSNeu = 2*Math.PI+xSNeu;//damit  xNeu > 0
        d = Math.sqrt((xSpecial-xSNeu)*(xSpecial-xSNeu)+(ySpecial-ySNeu)*(ySpecial-ySNeu)); 
        println(d);
         if (d > massFuerUnendlich) {
          break;  // Raus!
        }
        xS = xSNeu;yS = ySNeu;
        i++;
      }
  }
  

  if (key == 's') save("standardMapFlucht.png");
  redraw();
}
/////////////////////////////////////////////////////////////////
